#include <iostream>
#include <string>
#include <vector>

const bool CUT_ALL_SUBSTRINGS = 1;     // После того как программа найдёт одну подстроку, она начнёт искать следующую, до тех пор, пока они не кончатся
const bool SHOW_LEN = 0;               // Выводить длинну строки в функции print

using namespace std;


class MyString{
    public:
        MyString(string str, int len);
        MyString(string str);
        MyString(vector <char> str);
        ~MyString();
        vector <char> getStr();
        int len();
        void print();
        MyString operator + (MyString s2);
        MyString operator - (MyString s2);
        int getCount();
    private:
        void init(string str, int len);
        int _len = 0;
        vector <char> _str;
        static int _counter;
};
int MyString::_counter = 0;

void MyString::init(string str, int len){
    MyString::_len = len;
    for(int i=0; i<str.length(); i++){
        _str.push_back(str[i]);
    }
    _str.push_back('\n');
}


MyString::MyString(string str, int len){
    if(str.length()>=len){
        init(str, len);
    }else{
        cout << "Ошибка! Переданная строка больше заданного размера!\n";
    }
    _counter++;
}


MyString::MyString(string str){
    int len = str.length();
    init(str, len);
    _counter++;
}


MyString::MyString(vector <char> str){
    _len = str.size()+1;
    _str = str;
    _str.push_back('\n');
    _counter++;
}


MyString::~MyString(){
    _counter--;
    cout << "Удаление объекта\n";
}


vector <char> MyString::getStr(){
    return _str;
}


int MyString::len(){
    return _len;
}


void MyString::print(){
    if(SHOW_LEN){
        cout << "Len: " << _len << endl;
    }
    for(int i=0; i<=_len; i++){
        cout << MyString::_str[i];
    }
}


MyString MyString::operator + (MyString s2){
    vector <char> tmp(_str);
    tmp.pop_back();
    vector <char> str2(s2.getStr());
    for(int i=0; i<s2.len(); i++){
        tmp.push_back(str2[i]);
    }
    tmp.push_back('\n');
    return MyString(tmp);
}


MyString MyString::operator - (MyString s2){
    int len = s2.len();  
    int buff_len = _len; 
    vector <char> buff(_str);
    buff.pop_back();

    if(len<buff_len){

        vector <char> str_v(s2.getStr());
        str_v.pop_back();

        for(int j=0; j<buff_len; j++){
            
            if((buff_len-j)<len){
                break;
            }

            vector <char> tmp;
            
            for(int i=j; i<len+j; i++){
                tmp.push_back(buff[i]);
                
            }

            if(tmp == str_v){
                vector <char> buff2;
                for(int i=0;i<buff_len;i++){
                    if(i>=j && i<(j+len)){
                        continue;
                    }
                    buff2.push_back(buff[i]);
                }
                buff.clear();
                int new_len = buff_len-len;
                for(int k=0; k<new_len; k++){
                    buff.push_back(buff2[k]);
                }
                buff_len = new_len;
                if(!CUT_ALL_SUBSTRINGS){
                    break;  
                }
            }
        }
    }
    return MyString(buff);
}

int MyString::getCount(){
    return _counter;
}


// --------------------------------------------MAIN---------------------------
int main() {


    MyString s (string("str1"), 4);
    cout << "Исходная строка "; s.print();
    cout << "Объектов класса: " << s.getCount() << endl;
    MyString s2 (string("concatination_con1"));
    cout << "Исходная строка "; s2.print();
    cout << "Объектов класса: " << s.getCount() << endl;
    cout << "После конкатенации "; (s+s2).print();
    MyString s3(string("con"));
    cout << "Объектов класса: " << s3.getCount() << endl;
    MyString s4(s2-s3);
    cout << "Вырезанная подстрока "; s4.print();
    cout << "Объектов класса: " << s4.getCount() << endl;

    return 0;
}